/*!
 * lap-core-js v1.3.22
 * MIT Licensed
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["lap"] = factory();
	else
		root["lap"] = factory();
})(window, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

/*! js-cookie v3.0.1 | MIT */
;
(function (global, factory) {
   true ? module.exports = factory() :
  undefined;
}(this, (function () { 'use strict';

  /* eslint-disable no-var */
  function assign (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        target[key] = source[key];
      }
    }
    return target
  }
  /* eslint-enable no-var */

  /* eslint-disable no-var */
  var defaultConverter = {
    read: function (value) {
      if (value[0] === '"') {
        value = value.slice(1, -1);
      }
      return value.replace(/(%[\dA-F]{2})+/gi, decodeURIComponent)
    },
    write: function (value) {
      return encodeURIComponent(value).replace(
        /%(2[346BF]|3[AC-F]|40|5[BDE]|60|7[BCD])/g,
        decodeURIComponent
      )
    }
  };
  /* eslint-enable no-var */

  /* eslint-disable no-var */

  function init (converter, defaultAttributes) {
    function set (key, value, attributes) {
      if (typeof document === 'undefined') {
        return
      }

      attributes = assign({}, defaultAttributes, attributes);

      if (typeof attributes.expires === 'number') {
        attributes.expires = new Date(Date.now() + attributes.expires * 864e5);
      }
      if (attributes.expires) {
        attributes.expires = attributes.expires.toUTCString();
      }

      key = encodeURIComponent(key)
        .replace(/%(2[346B]|5E|60|7C)/g, decodeURIComponent)
        .replace(/[()]/g, escape);

      var stringifiedAttributes = '';
      for (var attributeName in attributes) {
        if (!attributes[attributeName]) {
          continue
        }

        stringifiedAttributes += '; ' + attributeName;

        if (attributes[attributeName] === true) {
          continue
        }

        // Considers RFC 6265 section 5.2:
        // ...
        // 3.  If the remaining unparsed-attributes contains a %x3B (";")
        //     character:
        // Consume the characters of the unparsed-attributes up to,
        // not including, the first %x3B (";") character.
        // ...
        stringifiedAttributes += '=' + attributes[attributeName].split(';')[0];
      }

      return (document.cookie =
        key + '=' + converter.write(value, key) + stringifiedAttributes)
    }

    function get (key) {
      if (typeof document === 'undefined' || (arguments.length && !key)) {
        return
      }

      // To prevent the for loop in the first place assign an empty array
      // in case there are no cookies at all.
      var cookies = document.cookie ? document.cookie.split('; ') : [];
      var jar = {};
      for (var i = 0; i < cookies.length; i++) {
        var parts = cookies[i].split('=');
        var value = parts.slice(1).join('=');

        try {
          var foundKey = decodeURIComponent(parts[0]);
          jar[foundKey] = converter.read(value, foundKey);

          if (key === foundKey) {
            break
          }
        } catch (e) {}
      }

      return key ? jar[key] : jar
    }

    return Object.create(
      {
        set: set,
        get: get,
        remove: function (key, attributes) {
          set(
            key,
            '',
            assign({}, attributes, {
              expires: -1
            })
          );
        },
        withAttributes: function (attributes) {
          return init(this.converter, assign({}, this.attributes, attributes))
        },
        withConverter: function (converter) {
          return init(assign({}, this.converter, converter), this.attributes)
        }
      },
      {
        attributes: { value: Object.freeze(defaultAttributes) },
        converter: { value: Object.freeze(converter) }
      }
    )
  }

  var api = init(defaultConverter, { path: '/' });
  /* eslint-enable no-var */

  return api;

})));


/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, "init", function() { return /* binding */ init; });
__webpack_require__.d(__webpack_exports__, "getVideoAd", function() { return /* binding */ getVideoAd; });
__webpack_require__.d(__webpack_exports__, "getAudioAd", function() { return /* binding */ getAudioAd; });
__webpack_require__.d(__webpack_exports__, "getInterstitialAd", function() { return /* binding */ getInterstitialAd; });

// CONCATENATED MODULE: ./node_modules/tslib/tslib.es6.js
/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    if (typeof b !== "function" && b !== null)
        throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    }
    return __assign.apply(this, arguments);
}

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __param(paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

var __createBinding = Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
        desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
});

function __exportStar(m, o) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p)) __createBinding(o, m, p);
}

function __values(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
}

function __read(o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
}

/** @deprecated */
function __spread() {
    for (var ar = [], i = 0; i < arguments.length; i++)
        ar = ar.concat(__read(arguments[i]));
    return ar;
}

/** @deprecated */
function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

function __spreadArray(to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
}

function __await(v) {
    return this instanceof __await ? (this.v = v, this) : new __await(v);
}

function __asyncGenerator(thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
}

function __asyncDelegator(o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
}

function __asyncValues(o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
}

function __makeTemplateObject(cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};

var __setModuleDefault = Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
};

function __importStar(mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
}

function __importDefault(mod) {
    return (mod && mod.__esModule) ? mod : { default: mod };
}

function __classPrivateFieldGet(receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
}

function __classPrivateFieldSet(receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
}

function __classPrivateFieldIn(state, receiver) {
    if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function")) throw new TypeError("Cannot use 'in' operator on non-object");
    return typeof state === "function" ? receiver === state : state.has(receiver);
}

// CONCATENATED MODULE: ./node_modules/@fingerprintjs/fingerprintjs-pro/dist/fp.esm.min.js
/**
 * FingerprintJS Pro v3.8.1 - Copyright (c) FingerprintJS, Inc, 2022 (https://fingerprint.com)
 *
 * This software contains code from open-source projects:
 * MurmurHash3 by Karan Lyons (https://github.com/karanlyons/murmurHash3.js)
 */

function fp_esm_min_n(e,t){return function(e,t){return Object.prototype.hasOwnProperty.call(e,t)}(e,t)?e[t]:void 0}function fp_esm_min_o(e){for(var t="",r=0;r<e.length;++r)if(r>0){var n=e[r].toLowerCase();n!==e[r]?t+=" "+n:t+=e[r]}else t+=e[r].toUpperCase();return t}var fp_esm_min_i={default:"endpoint"},fp_esm_min_u={default:"tlsEndpoint"},fp_esm_min_a="Client timeout",fp_esm_min_R="Network connection error",fp_esm_min_c="Network request aborted",fp_esm_min_d="Response cannot be parsed",fp_esm_min_s="Blocked by CSP",fp_esm_min_l=/*#__PURE__*/fp_esm_min_o("WrongRegion"),f=/*#__PURE__*/fp_esm_min_o("SubscriptionNotActive"),E=/*#__PURE__*/fp_esm_min_o("UnsupportedVersion"),p=/*#__PURE__*/fp_esm_min_o("InstallationMethodRestricted"),_=/*#__PURE__*/fp_esm_min_o("HostnameRestricted"),O=/*#__PURE__*/fp_esm_min_o("IntegrationFailed"),I="API key required",v="API key not found",h="API key expired",N="Request cannot be parsed",P="Request failed",A="Request failed to process",T="Too many requests, rate limit exceeded",y="Not available for this origin",m="Not available with restricted header",w="API key required",S="API key not found",k="API key expired";function b(t,r){var n=[];return function(t,r){var n=5,o=(d=t,s=__spreadArrays(d),{current:function(){return s[0]},postpone:function(){var e=s.shift();void 0!==e&&s.push(e)},exclude:function(){s.shift()}}),i=(a=100,R=3e3,c=0,function(){return Math.random()*Math.min(R,a*Math.pow(2,c++))}),u=o.current();var a,R,c;var d,s;if(void 0===u)return Promise.reject(new TypeError("The list of script URL patterns is empty"));var l=function(e,t){return r(e).catch((function(e){if(t+1>=n)throw e;!function(e){if(!(e instanceof Error))return!1;var t=e.message;return"Blocked by CSP"===t||"9319"===t}(e)?o.postpone():o.exclude();var r,u=o.current();if(void 0===u)throw e;return(r=i(),new Promise((function(e){return setTimeout(e,r)}))).then((function(){return l(u,t+1)}))}))};return l(u,0)}(t,(function(e){var t=new Date,o=function(){return n.push({url:e,startedAt:t,finishedAt:new Date})},i=r(e);return i.then(o,o),i})).then((function(e){return[e,{attempts:n}]}))}var D="https://fpnpmcdn.net/v<version>/<apiKey>/loader_v<loaderVersion>.js",C=D,U="Failed to load the JS script of the agent";function g(e){var o;e.scriptUrlPattern;var i=e.token,u=e.apiKey,a=void 0===u?i:u,R=__rest(e,["scriptUrlPattern","token","apiKey"]),c=null!==(o=fp_esm_min_n(e,"scriptUrlPattern"))&&void 0!==o?o:D;return Promise.resolve().then((function(){if(!a||"string"!=typeof a)throw new Error("API key required");return b(function(e,t){return(Array.isArray(e)?e:[e]).map((function(e){return function(e,t){var r=encodeURIComponent;return e.replace(/<[^<>]+>/g,(function(e){return"<version>"===e?"3":"<apiKey>"===e?r(t):"<loaderVersion>"===e?r("3.8.1"):e}))}(String(e),t)}))}(c,a),L).catch(B)})).then((function(e){var t=e[0],n=e[1];return t.load(__assign(__assign({},R),{ldi:n}))}))}function L(e){return function(e,t,r,n){var o,i=document,u="securitypolicyviolation",a=function(t){var r=new URL(e,location.href),n=t.blockedURI;n!==r.href&&n!==r.protocol.slice(0,-1)&&n!==r.origin||(o=t,R())};i.addEventListener(u,a);var R=function(){return i.removeEventListener(u,a)};return null==n||n.then(R,R),Promise.resolve().then(t).then((function(e){return R(),e}),(function(e){return new Promise((function(e){return setTimeout(e)})).then((function(){if(R(),o)return r(o);throw e}))}))}(e,(function(){return function(e){return new Promise((function(t,r){var n=document.createElement("script"),o=function(){var e;return null===(e=n.parentNode)||void 0===e?void 0:e.removeChild(n)},i=document.head||document.getElementsByTagName("head")[0];n.onload=function(){o(),t()},n.onerror=function(){o(),r(new Error(U))},n.async=!0,n.src=e,i.appendChild(n)}))}(e)}),(function(){throw new Error("Blocked by CSP")})).then(q)}function q(){var e=window,t="__fpjs_p_l_b",r=e[t];if(function(e,t){var r,n=null===(r=Object.getOwnPropertyDescriptor)||void 0===r?void 0:r.call(Object,e,t);(null==n?void 0:n.configurable)?delete e[t]:n&&!n.writable||(e[t]=void 0)}(e,t),"function"!=typeof(null==r?void 0:r.load))throw new Error("9319");return r}function B(e){throw e instanceof Error&&"9319"===e.message?new Error(U):e}var K={load:g,defaultScriptUrlPattern:C,ERROR_SCRIPT_LOAD_FAIL:U,ERROR_API_KEY_EXPIRED:"API key expired",ERROR_API_KEY_INVALID:"API key not found",ERROR_API_KEY_MISSING:"API key required",ERROR_BAD_REQUEST_FORMAT:"Request cannot be parsed",ERROR_BAD_RESPONSE_FORMAT:"Response cannot be parsed",ERROR_CLIENT_TIMEOUT:"Client timeout",ERROR_CSP_BLOCK:"Blocked by CSP",ERROR_FORBIDDEN_ENDPOINT:_,ERROR_FORBIDDEN_HEADER:"Not available with restricted header",ERROR_FORBIDDEN_ORIGIN:"Not available for this origin",ERROR_GENERAL_SERVER_FAILURE:"Request failed",ERROR_INSTALLATION_METHOD_RESTRICTED:p,ERROR_INTEGRATION_FAILURE:O,ERROR_NETWORK_ABORT:"Network request aborted",ERROR_NETWORK_CONNECTION:"Network connection error",ERROR_RATE_LIMIT:"Too many requests, rate limit exceeded",ERROR_SERVER_TIMEOUT:"Request failed to process",ERROR_SUBSCRIPTION_NOT_ACTIVE:f,ERROR_TOKEN_EXPIRED:"API key expired",ERROR_TOKEN_INVALID:"API key not found",ERROR_TOKEN_MISSING:"API key required",ERROR_UNSUPPORTED_VERSION:E,ERROR_WRONG_REGION:fp_esm_min_l,defaultEndpoint:fp_esm_min_i,defaultTlsEndpoint:fp_esm_min_u};

// EXTERNAL MODULE: ./node_modules/js-cookie/dist/js.cookie.js
var js_cookie = __webpack_require__(0);
var js_cookie_default = /*#__PURE__*/__webpack_require__.n(js_cookie);

// CONCATENATED MODULE: ./src/index.ts
var src_awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var src_generator = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};


var VERSION = "1.3.22";
var BASE_DOMAIN = "https://lap-api.com";
var VideoType;
(function (VideoType) {
    VideoType[VideoType["vast"] = 0] = "vast";
    VideoType[VideoType["vmap"] = 1] = "vmap";
})(VideoType || (VideoType = {}));
var CookiesNames;
(function (CookiesNames) {
    CookiesNames["UID"] = "lap_u";
    CookiesNames["VISITS"] = "lap_v";
    CookiesNames["BANNER_SIZES"] = "lap_b_s";
})(CookiesNames || (CookiesNames = {}));
var getPixels = function (size) { return size.toString() + "px"; };
function getUid() {
    return src_awaiter(this, void 0, void 0, function () {
        var preUid, fpPromise, results, uid, e_1;
        return src_generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    preUid = js_cookie_default.a.get(CookiesNames.UID);
                    if (preUid) {
                        return [2 /*return*/, preUid];
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 4, , 5]);
                    return [4 /*yield*/, K.load({
                            apiKey: "vBo0DIT6ZcFq1VUX15y5",
                            region: "eu"
                        })];
                case 2:
                    fpPromise = _a.sent();
                    return [4 /*yield*/, fpPromise.get()];
                case 3:
                    results = _a.sent();
                    uid = results.visitorId;
                    js_cookie_default.a.set(CookiesNames.UID, uid, {
                        expires: 99999,
                        path: '/'
                    });
                    return [2 /*return*/, uid];
                case 4:
                    e_1 = _a.sent();
                    console.error("Failed to get uid: ".concat(e_1));
                    return [2 /*return*/, null];
                case 5: return [2 /*return*/];
            }
        });
    });
}
function getBannerSizes() {
    return src_awaiter(this, void 0, void 0, function () {
        var preSizes, response, sizes;
        return src_generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    preSizes = js_cookie_default.a.get(CookiesNames.BANNER_SIZES);
                    if (preSizes) {
                        return [2 /*return*/, JSON.parse(preSizes)];
                    }
                    return [4 /*yield*/, fetch(getUrl("b", {}, "sizes"))];
                case 1:
                    response = _a.sent();
                    if (!response.ok) {
                        throw new Error("Failed to get banner sizes");
                    }
                    return [4 /*yield*/, response.json()];
                case 2:
                    sizes = _a.sent();
                    js_cookie_default.a.set(CookiesNames.BANNER_SIZES, JSON.stringify(sizes), {
                        path: '/'
                    });
                    return [2 /*return*/, sizes];
            }
        });
    });
}
function getUrl(endpoint, params, path) {
    if (path === void 0) { path = ""; }
    return "".concat(BASE_DOMAIN, "/").concat(endpoint).concat(path == "" ? "" : "/" + path, "?").concat(new URLSearchParams(params).toString());
}
function checkForUpdate() {
    return src_awaiter(this, void 0, void 0, function () {
        var response, settings, e_2;
        return src_generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 3, , 4]);
                    return [4 /*yield*/, fetch(getUrl("settings", {}))];
                case 1:
                    response = _a.sent();
                    if (!response.ok) {
                        console.error("Failed to get update status");
                    }
                    return [4 /*yield*/, response.json()];
                case 2:
                    settings = _a.sent();
                    return [2 /*return*/, settings.library_version != VERSION ? settings.library_version : null];
                case 3:
                    e_2 = _a.sent();
                    console.error("Failed to get update status: ".concat(e_2));
                    return [2 /*return*/, null];
                case 4: return [2 /*return*/];
            }
        });
    });
}
function getAudioAdData(app, uid) {
    return src_awaiter(this, void 0, void 0, function () {
        var response;
        return src_generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, fetch(getUrl("a", { app: app, uid: uid }))];
                case 1:
                    response = _a.sent();
                    if (!response.ok) {
                        throw new Error("Failed to get audio ad data");
                    }
                    else if (response.status == 204) {
                        return [2 /*return*/, null];
                    }
                    return [4 /*yield*/, response.json()];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function getVideoAdUrl(app, uid, type) {
    return getUrl("v", { app: app, uid: uid }, type.toString());
}
function addClasses(element, classes, defaultClasses) {
    if (defaultClasses === void 0) { defaultClasses = ""; }
    if (typeof classes === "string") {
        element.className = defaultClasses + " " + classes;
    }
    else if (classes instanceof Array) {
        element.className = defaultClasses + " " + classes.join(" ");
    }
    else {
        element.className = defaultClasses;
    }
}
var LapB = /** @class */ (function () {
    function LapB(uid, app, element, autoRender, sizeId) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        if (element === void 0) { element = document.body; }
        var _this = this;
        this.uid = uid;
        this.app = app;
        this.element = element;
        this.autoRender = autoRender;
        this.sizeId = sizeId;
        getBannerSizes().then(function (sizes) {
            _this.bannerSize = sizes.find(function (size) { return size.id == sizeId; }) || sizes[0];
            if (_this.bannerSize) {
                _this.render();
            }
        });
    }
    LapB.init = function (uid, app) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        document.querySelectorAll("[data-lap-b]").forEach(function (element) {
            new LapB(uid, app, element, element.getAttribute("data-lap-b-render") === "auto", element.getAttribute("data-lap-b").toUpperCase() || "B");
        });
    };
    LapB.prototype.render = function () {
        this.iframe = document.createElement("iframe");
        this.iframe.src = getUrl("b", {
            app: this.app,
            uid: this.uid,
            size: this.sizeId,
            reload_auto: this.autoRender
        });
        this.iframe.style.border = "none";
        this.iframe.style.cursor = "pointer";
        this.iframe.style.width = getPixels(this.bannerSize.width);
        this.iframe.style.height = getPixels(this.bannerSize.height);
        this.element.appendChild(this.iframe);
        this.element.style.width = getPixels(this.bannerSize.width);
        this.element.style.height = getPixels(this.bannerSize.height);
        this.element.classList.add("lap-b-container");
        this.iframe.classList.add("lap-b-iframe");
    };
    return LapB;
}());
var LapN = /** @class */ (function () {
    function LapN(uid, app, element, nativeAdClasses) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        if (nativeAdClasses === void 0) { nativeAdClasses = {}; }
        this.impressed = false;
        this.uid = uid;
        this.app = app;
        this.element = element;
        this.impressed = false;
        this.render();
        // set this.classes based on element attributes, if provided
        this.classes = {
            container: this.element.getAttribute("data-lap-n-container") || nativeAdClasses.container || "",
            title: this.element.getAttribute("data-lap-n-title") || nativeAdClasses.title || "",
            content: this.element.getAttribute("data-lap-n-content") || nativeAdClasses.content || "",
            image: this.element.getAttribute("data-lap-n-image") || nativeAdClasses.image || "",
            textContainer: this.element.getAttribute("data-lap-n-text-container") || nativeAdClasses.textContainer || "",
        };
        this.scrollListener = this.scrollListener.bind(this);
    }
    LapN.init = function (uid, app, nativeAdClasses) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        document.querySelectorAll("[data-lap-n]").forEach(function (element) {
            new LapN(uid, app, element, nativeAdClasses);
        });
    };
    LapN.prototype.render = function () {
        return src_awaiter(this, void 0, void 0, function () {
            var response, _a, textContainer, title, content, image;
            var _this = this;
            return src_generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, fetch(getUrl("n", { app: this.app, uid: this.uid }))];
                    case 1:
                        response = _b.sent();
                        _a = this;
                        return [4 /*yield*/, response.json()];
                    case 2:
                        _a.data = _b.sent();
                        textContainer = document.createElement("div");
                        addClasses(textContainer, this.classes.textContainer, "lap-n-text-container");
                        textContainer.style.direction = "rtl";
                        title = document.createElement("h4");
                        title.innerText = this.data.title;
                        addClasses(title, this.classes.title, "lap-n-title");
                        title.style.margin = "8px";
                        textContainer.appendChild(title);
                        if (this.data.content) {
                            content = document.createElement("p");
                            content.innerText = this.data.content;
                            addClasses(content, this.classes.content, "lap-n-content");
                            content.style.margin = "8px";
                            textContainer.appendChild(content);
                        }
                        image = document.createElement("img");
                        image.src = this.data.image_url;
                        addClasses(image, this.classes.image, "lap-n-image");
                        this.element.appendChild(textContainer);
                        this.element.appendChild(image);
                        this.element.addEventListener("click", function () { return window.open(_this.data.url, "_blank"); });
                        this.element.style.cursor = "pointer";
                        this.element.style.maxWidth = "90vw";
                        this.element.style.display = "flex";
                        this.element.style.flexDirection = "column";
                        addClasses(this.element, this.classes.container, "lap-n-container");
                        this.scrollListener();
                        document.addEventListener("scroll", this.scrollListener, { passive: true });
                        return [2 /*return*/];
                }
            });
        });
    };
    LapN.prototype.scrollListener = function () {
        var _a;
        if (this.impressed)
            return;
        if (this.element.getBoundingClientRect().top < window.innerHeight) {
            document.removeEventListener("scroll", this.scrollListener);
            this.impressed = true;
            fetch((_a = this.data) === null || _a === void 0 ? void 0 : _a.impression_url, { method: "POST" });
        }
    };
    return LapN;
}());
var src_LapI = /** @class */ (function () {
    function LapI(uid, app) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        this.uid = uid;
        this.app = app;
        this.render();
    }
    LapI.init = function (uid, app, visits) {
        if (uid === void 0) { uid = "default-uid-web"; }
        if (app === void 0) { app = "default-app-web"; }
        if (visits === void 0) { visits = 4; }
        if (visits == 0)
            return;
        var visitsCookie = js_cookie_default.a.get(CookiesNames.VISITS);
        if (visitsCookie === undefined) {
            js_cookie_default.a.set(CookiesNames.VISITS, "0");
        }
        else {
            var visitsNumber = parseInt(visitsCookie);
            if (visitsNumber >= visits) {
                new LapI(uid, app);
                js_cookie_default.a.set(CookiesNames.VISITS, "0");
            }
            else {
                js_cookie_default.a.set(CookiesNames.VISITS, String(visitsNumber + 1));
            }
        }
    };
    LapI.prototype.render = function () {
        var _this = this;
        this.div = document.createElement("div");
        this.div.style.position = "fixed";
        this.div.style.top = "0";
        this.div.style.left = "0";
        this.div.style.width = "100vw";
        this.div.style.height = "100vh";
        this.div.style.backgroundColor = "rgba(255,255,255,0)";
        // add blur effect
        // @ts-ignore
        this.div.style.backdropFilter = "blur(5px)";
        this.div.style.zIndex = "9999999";
        this.div.style.display = "flex";
        this.div.style.justifyContent = "center";
        this.div.style.alignItems = "center";
        this.div.style.transition = "opacity 0.5s ease-in-out";
        document.documentElement.appendChild(this.div);
        var iframe = document.createElement("iframe");
        iframe.src = getUrl("i", { app: this.app, uid: this.uid });
        iframe.style.border = "none";
        iframe.style.width = "100vw";
        iframe.style.height = "100vh";
        this.div.appendChild(iframe);
        var close = document.createElement("div");
        var cssText = "\n                position: absolute;\n                top: 0px;\n                right: 0px;\n                background: rgb(150, 150, 150);\n                color: white;\n                padding: 8px;\n                cursor: pointer;\n                z-index: 99999999;\n                border-radius: 100%;\n                border: 1px solid white;\n                margin: 16px;\n                transform: scale(1);\n                transition: transform 0.5s ease-in-out 0s;\n             \n                display: flex;\n                align-items: center;\n                justify-content: center;\n                           \n                display: flex;\n                align-items: center;\n                justify-content: center;\n            ".trim();
        close.innerHTML = "&#215;";
        var screenWidth = window.innerWidth;
        if (screenWidth > 800) {
            cssText += "\n                width: 2rem;\n                height: 2rem;\n                font-size: 2rem;\n            ".trim();
        }
        else {
            cssText += "\n               width: 1rem;\n               height: 1rem;\n               font-size: 2rem;\n            ".trim();
        }
        close.style.cssText = cssText;
        setTimeout(function () {
            close.style.transform = "scale(1)";
        }, 3000);
        close.addEventListener("click", function () { return _this.div.style.opacity = "0"; });
        // close.addEventListener("mouseenter", () => close.style.transform = "rotate(90deg)");
        // close.addEventListener("mouseleave", () => close.style.transform = "rotate(0deg)");
        this.div.addEventListener("transitionend", function (e) {
            if (e.propertyName === "opacity" && _this.div.style.opacity === "0") {
                document.documentElement.removeChild(_this.div);
            }
        });
        iframe.addEventListener("load", function () {
            _this.div.appendChild(close);
        });
    };
    return LapI;
}());
/**
 * Initialize the library.
 * @param app - The app name. You need to provide the exact same name that given to you by the Lap team.
 * @param options - The options object.
 */
function init(app, options) {
    if (app === void 0) { app = "default-app-web"; }
    if (options === void 0) { options = {
        interstitialInterval: 4,
        nativeAdClasses: {}
    }; }
    return src_awaiter(this, void 0, void 0, function () {
        var uid, needToUpdate;
        return src_generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, getUid()];
                case 1:
                    uid = _a.sent();
                    return [4 /*yield*/, getBannerSizes()];
                case 2:
                    _a.sent();
                    LapB.init(uid, app);
                    src_LapI.init(uid, app, options.interstitialInterval);
                    LapN.init(uid, app, options.nativeAdClasses);
                    return [4 /*yield*/, checkForUpdate()];
                case 3:
                    needToUpdate = _a.sent();
                    console.log("%cLap initialized with version %c`".concat(VERSION, "` %con %c`").concat(app, "`."), "color: #a67a00; font-size: 14px; font-weight: bold;", "color: #fcba03; font-size: 14px; font-style: italic;", "color: #a67a00; font-size: 14px; font-weight: bold;", "color: #fcba03; font-size: 14px; font-style: italic;");
                    if (needToUpdate) {
                        console.log("%cLap %c`".concat(needToUpdate, "` %cis available, please update your library."), "color: #a67a00; font-size: 12px; font-weight: bold;", "color: #fcba03; font-size: 12px; font-style: italic;", "color: #a67a00; font-size: 12px; font-weight: bold;");
                    }
                    return [2 /*return*/, {
                            version: VERSION,
                            app: app,
                            getVideoAd: function (type) { return getVideoAd(type, app); },
                            getAudioAd: function () { return getAudioAd(app); },
                            getInterstitialAd: function () { return getInterstitialAd(app); },
                        }];
            }
        });
    });
}
function getVideoAd(type, app) {
    if (type === void 0) { type = VideoType.vmap; }
    return src_awaiter(this, void 0, void 0, function () {
        var uid;
        return src_generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!app) {
                        app = "default-app-web";
                        console.warn("No app specified, using default app");
                    }
                    return [4 /*yield*/, getUid()];
                case 1:
                    uid = _a.sent();
                    return [2 /*return*/, getVideoAdUrl(app, uid, type)];
            }
        });
    });
}
function getAudioAd(app) {
    return src_awaiter(this, void 0, void 0, function () {
        var uid;
        return src_generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!app) {
                        app = "default-app-web";
                        console.warn("No app specified, using default app");
                    }
                    return [4 /*yield*/, getUid()];
                case 1:
                    uid = _a.sent();
                    return [4 /*yield*/, getAudioAdData(app, uid)];
                case 2: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
function getInterstitialAd(app) {
    return src_awaiter(this, void 0, void 0, function () {
        var uid;
        return src_generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!app) {
                        app = "default-app-web";
                        console.warn("No app specified, using default app");
                    }
                    return [4 /*yield*/, getUid()];
                case 1:
                    uid = _a.sent();
                    new src_LapI(uid, app);
                    return [2 /*return*/];
            }
        });
    });
}
var lapObject = {
    version: VERSION,
    init: init,
    getVideoAd: getVideoAd,
    getAudioAd: getAudioAd,
    getInterstitialAd: getInterstitialAd,
};
/* harmony default export */ var src = __webpack_exports__["default"] = (lapObject);


/***/ })
/******/ ])["default"];
});